using Grasshopper;
using Grasshopper.Kernel;
using Rhino.Geometry;
using System;
using System.Collections.Generic;
using Grasshopper.Kernel.Special;
using  System.Linq;
using Grasshopper.Kernel.Parameters;

namespace offset
{
public class offsetComponent : GH_Component
{
            public offsetComponent()
: base("offset", "Nickname",
"Description",
"test", "Offset")
{
}

protected override void RegisterInputParams(GH_Component.GH_InputParamManager pManager)
{
pManager.AddPlaneParameter("plan", "p", "plan", GH_ParamAccess.item);
pManager.AddCurveParameter("curve", "c", "curve", GH_ParamAccess.item);
pManager.AddNumberParameter("Distance", "d", "distance", GH_ParamAccess.item);
pManager.AddIntegerParameter("style", "s", "style", GH_ParamAccess.item);
Param_Integer param = pManager[3] as Param_Integer;

            param.AddNamedValue("None", 0);
    param.AddNamedValue("Sharp", 1);
    param.AddNamedValue("Round", 2);
    param.AddNamedValue("Smooth", 3);
    param.AddNamedValue("Chamfer", 4);

}

protected override void RegisterOutputParams(GH_Component.GH_OutputParamManager pManager)
{
    pManager.AddCurveParameter("curve", "c", "curve", GH_ParamAccess.item);
}

protected override void SolveInstance(IGH_DataAccess da)
{
Curve[] Offset;
Curve cu = null;
var plane = new Plane(Plane.WorldXY);
var d = 0;
var style = CurveOffsetCornerStyle.Sharp;
da.GetData(0, ref plane);
da.GetData(1, ref cu);
da.GetData(2, ref d);
da.GetData(3, ref style);

{
    Offset = cu.Offset(plane, d, 0.01, style);
    da.SetData(0, Offset);
}
}

protected override System.Drawing.Bitmap Icon => null;

public override Guid ComponentGuid => new Guid("851F9350-8A95-4EBE-8EE1-A6A567974185");
}
}